/***********************************************************************************

	 RP Server.
	 1, 0, 4, 1.
	22.04.2011. 
	  RP   3.

***********************************************************************************/

/***********************************************************************************
	 
***********************************************************************************/
	
	IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[xModelVer]') AND type = 'U')
		DROP TABLE [dbo].[xModelVer]
	GO

	IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[xRepositoryVer]') AND type = 'U')
		DROP TABLE [dbo].[xRepositoryVer]
	GO

	CREATE TABLE [dbo].[xRepositoryVer]
	(
		[ResVer]		int NOT NULL,
		[ResSubVer]		int NOT NULL,
		[ModelVer]		int NOT NULL,
		[ModelSubVer]	int NOT NULL
	)
	GO

	INSERT INTO [xRepositoryVer] ([ResVer], [ResSubVer], [ModelVer], [ModelSubVer]) VALUES (1, 0, 4, 1)
	GO

	GRANT SELECT ON [dbo].[xRepositoryVer]		TO PUBLIC
	GO
	
/***********************************************************************************/

IF EXISTS (SELECT 0 FROM sys.columns C JOIN sys.objects O ON C.object_id = O.object_id WHERE C.name = 'InstallData' AND O.name = 'xHelp')
	EXEC sp_rename 'dbo.xHelp.InstallData', 'InstallDate', 'COLUMN';
GO

/***********************************************************************************
	[x_report]
***********************************************************************************/

if not exists (select * from sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[x_reportbak]') and type = 'U')
CREATE TABLE [dbo].[x_reportbak]
(
	[id_report] [int] IDENTITY(1,1) NOT NULL,
	[name_report] varchar(246) NOT NULL,
	[filename] varchar(246) NOT NULL,
	[extention] varchar(6) NOT NULL,
	[description] varchar(255) NULL,
	[owner] varchar(255) NULL,
	[filesize] int NOT NULL,
	[state] int NULL,
	[zipsize] int NULL,
	[date_edit] datetime NOT NULL,
	[data] [varbinary] (max) NULL,
	[uname] varchar(32) NULL,
	[mdate] datetime NULL
)
GO

ALTER TABLE [dbo].[x_report] ADD DEFAULT (suser_sname()) FOR [owner]
GO

IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[PROTOCOL_reoprt_CHNG]'))
	DROP TRIGGER [dbo].[PROTOCOL_reoprt_CHNG]
GO

IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[TUD_X_REPORT]'))
	DROP TRIGGER [dbo].[TUD_X_REPORT]
GO

CREATE TRIGGER [dbo].[TUD_X_REPORT] ON [dbo].[x_report] AFTER UPDATE, DELETE AS
BEGIN
	INSERT INTO x_reportbak (name_report, filename, extention, description, owner, filesize, state, zipsize, date_edit, data, mdate, uname)
	SELECT R.name_report, R.filename, R.extention, R.description, R.owner, R.filesize, R.state, R.zipsize, R.date_edit, R.data, getdate(), suser_sname()
	  FROM DELETED D, x_report R
	 WHERE D.id_report = R.id_report

	IF EXISTS (SELECT * FROM inserted)	--   UPDATE
	BEGIN
		IF ( NOT UPDATE([owner]) )  --    owner ,   suser_sname()
			UPDATE [x_report] SET [owner] = suser_sname() FROM [x_report] O, inserted I	WHERE O.[id_report] = I.[id_report]
	END
END
GO
